/*=======================================================
  Author:   R. Muth
  Version:  $Id: alto.c,v 1.15 1998/12/02 18:54:32 muth Exp $
  Comment:  This file contains the function main 
=======================================================*/

#include "global.h"
#include "functions.h"
#include "flags.h"

#include <unistd.h>
#include <sys/stat.h>

/*=======================================================
=======================================================*/

#undef __PROC__
#define __PROC__ "main"

int main(int argc, char *argv[])
{
    PrintSep0(stdout);
    fprintf(stdout,
            "Alto Version 0.1 (99/01/22)\n"
            "For more information check http://www.cs.arizona.edu/alto/\n");
    PrintSep0(stdout);

    ParseCommandLine(argc,argv);
    
    BinaryLoad();

    BinaryDisassemble(); 

    /*
    
    if( FLAG_PRINT_DNG )
    {
        CheckIns();
        CheckRel(); 
    }
    */


    BinaryConstructFlowGraph();

    BinaryTrivialOpts();

    if( HasOption(PRINT_OPT_WHEN,"Preproc") )
        PrintAll(stdout);

    BinaryProcess();

    if( HasOption(PRINT_OPT_WHEN,"Postproc") )
        PrintAll(stdout);


#if 0
    OptRemoveUnreachableCode(stdout);
    ComputeSavedChangedRegisters(stdout);

    ComUseDef(stdout,1);
    ComInsDefPotential(stdout,1);
#endif
    
    ComputeCountCutOff(stdout,100,0.25,10);
    InfStatResource(stdout);

#if 0
    {
        INDEX ibbl;
        FOREACH_LIVE_BBL(ibbl)
            if( ABBL_COUNT(ibbl)> 1000000 )
                PrintBblSuper(stdout,ibbl);
        
               
    }
#endif

    if( HasOption(PRINT_OPT_WHEN,"Preasm") )
        PrintAll(stdout);

    BinaryAssemble();
    
    if( HasOption(PRINT_OPT_WHEN,"Postasm") )
        PrintAll(stdout);
        
    if( HasOption(PRINT_OPT_WHEN,"Presave") )
        PrintAll(stdout);

    unlink(CONFIG_OUTFILE);
    BinarySave();
    chmod(CONFIG_OUTFILE, S_IXUSR | S_IRUSR | S_IWUSR);
    
    if( HasOption(PRINT_OPT_WHEN,"Postsave") )
        PrintAll(stdout);

/*     instrumentOptimizedBinary(); */


    return 0;
}

/*=======================================================
=======================================================*/




