#ifndef ERROR_H
#define ERROR_H


extern void Error(char *mess, ... );
extern void PrintSep1(FILE *fp);
extern void PrintSep2(FILE *fp);
extern void PrintSep3(FILE *fp);

#define PROLOGUE(m) Error(m ": " __PROC__ ": ")

#define FATAL(mess)         {PROLOGUE("FATAL"); Error mess; exit(-1);}
#define CFATAL(cond,mess)   if (cond) {PROLOGUE("FATAL"); Error mess; exit(-1);}
#define ERROR(mess)         {PROLOGUE("ERROR"); Error mess;}
#define CASSERT(cond,mess)  if (!(cond)) {PROLOGUE("ASSERT"); Error mess;}
#define CERROR(cond,mess)   if (cond) {PROLOGUE("ERROR"); Error mess;}

#ifdef NO_NOISE
#define WARNING(mess) 
#define HURRAH(mess)
#define POTENTIAL(mess) 
#define CWARNING(cond,mess) 
#define CHURRAH(cond,mess) 
#else
#define WARNING(mess)       {PROLOGUE("WARNING"); Error mess;}
#define HURRAH(mess)        {PROLOGUE("HURRAH"); Error mess;}
#define POTENTIAL(mess)     {PROLOGUE("POTENTIAL"); Error mess;}
#define CWARNING(cond,mess) if (cond) {PROLOGUE("WARNING"); Error mess;}
#define CHURRAH(cond,mess) if (cond) {PROLOGUE("HURRAH"); Error mess;}
#endif

#define PRINT_FUN_BEG1() fprintf(stdout,"\n"),PrintSep1(stdout),fprintf(stdout,__PROC__ "\n"),PrintSep1(stdout)
#define PRINT_FUN_BEG2() fprintf(stdout,"\n"),PrintSep2(stdout),fprintf(stdout,__PROC__ "\n"),PrintSep2(stdout)

#define PRINT_FUN_END1() /*PrintSep1(stdout)*/
#define PRINT_FUN_END2() /*PrintSep2(stdout)*/

#endif /* ERROR_H */






