#include "global.h"
#include "functions.h"
#include "flags.h"
#include <stdio.h>
#include "opcode.h"
#include "regs.h"

#ifdef SYS_COFF
/* don't include these on linux-alpha */
#include <cmplrs/prof_header.h>
#include <cmplrs/pdf.h>
#include "system.coff.h"
#endif

#ifdef SYS_ELF
#include "system.elf.h"
#endif

#define CALL_PROF_SIZE 42*8
#define START_PROF 1000
#define AINS_USE_DEF_POTENTIAL(i) AINS_U1(i).quadword


static long foobar[110] = {
0xa4300000, /* <foo>    	ldq	t0, 0(a0) */
0x40203521, /* <foo+4>  	subq	t0, 0x1, t0 */
0xb4300000, /* <foo+8>  	stq	t0, 0(a0) */
0x40201da1, /* <foo+c>  	cmple	t0, 0x0, t0 */
0xe4200039, /* <foo+10> 	beq	t0, 00000000000000f8 <foo+f8> */
0x42011410, /* <foo+14> 	addq	a0, 0x8, a0 */
0x47ff0405, /* <foo+18> 	bis	zero, zero, t4 */
0x2ffe0000, /* <foo+1c> 	ldq_u	zero, 0(sp) */
0x44a50406, /* <foo+20> 	bis	t4, t4, t5 */
0x40a05404, /* <foo+24> 	addq	t4, 0x2, t3 */
0x4084bda1, /* <foo+28> 	cmple	t3, 0x25, t0 */
0xe420000d, /* <foo+2c> 	beq	t0, 0000000000000064 <foo+64> */
0x47ff041f, /* <foo+30> 	bis	zero, zero, zero */
0x2ffe0000, /* <foo+34> 	ldq_u	zero, 0(sp) */
0x47ff041f, /* <foo+38> 	bis	zero, zero, zero */
0x2ffe0000, /* <foo+3c> 	ldq_u	zero, 0(sp) */
0x40d00641, /* <foo+40> 	s8addq	t5, a0, t0 */
0x40900642, /* <foo+44> 	s8addq	t3, a0, t1 */
0xa4610008, /* <foo+48> 	ldq	t2, 8(t0) */
0xa4220008, /* <foo+4c> 	ldq	t0, 8(t1) */
0x40230da1, /* <foo+50> 	cmple	t0, t2, t0 */
0x44240486, /* <foo+54> 	cmoveq	t0, t3, t5 */
0x40805404, /* <foo+58> 	addq	t3, 0x2, t3 */
0x4084bda1, /* <foo+5c> 	cmple	t3, 0x25, t0 */
0xf43ffff7, /* <foo+60> 	bne	t0, 0000000000000040 <foo+40> */
0x40c50da1, /* <foo+64> 	cmple	t5, t4, t0 */
0xf420000a, /* <foo+68> 	bne	t0, 0000000000000094 <foo+94> */
0x40b00643, /* <foo+6c> 	s8addq	t4, a0, t2 */
0xa4830000, /* <foo+70> 	ldq	t3, 0(t2) */
0x40d00642, /* <foo+74> 	s8addq	t5, a0, t1 */
0xa4220000, /* <foo+78> 	ldq	t0, 0(t1) */
0xb4230000, /* <foo+7c> 	stq	t0, 0(t2) */
0xb4820000, /* <foo+80> 	stq	t3, 0(t1) */
0xa4830008, /* <foo+84> 	ldq	t3, 8(t2) */
0xa4220008, /* <foo+88> 	ldq	t0, 8(t1) */
0xb4230008, /* <foo+8c> 	stq	t0, 8(t2) */
0xb4820008, /* <foo+90> 	stq	t3, 8(t1) */
0x40a05405, /* <foo+94> 	addq	t4, 0x2, t4 */
0x40a27da1, /* <foo+98> 	cmple	t4, 0x13, t0 */
0xf43fffe0, /* <foo+9c> 	bne	t0, 0000000000000020 <foo+20> */
0x47e15405, /* <foo+a0> 	bis	zero, 0xa, t4 */
0x2ffe0000, /* <foo+a4> 	ldq_u	zero, 0(sp) */
0x47ff041f, /* <foo+a8> 	bis	zero, zero, zero */
0x2ffe0000, /* <foo+ac> 	ldq_u	zero, 0(sp) */
0x47ff041f, /* <foo+b0> 	bis	zero, zero, zero */
0x2ffe0000, /* <foo+b4> 	ldq_u	zero, 0(sp) */
0x47ff041f, /* <foo+b8> 	bis	zero, zero, zero */
0x2ffe0000, /* <foo+bc> 	ldq_u	zero, 0(sp) */
0x48a09723, /* <foo+c0> 	sll	t4, 0x4, t2 */
0x40700403, /* <foo+c4> 	addq	t2, a0, t2 */
0xa4300138, /* <foo+c8> 	ldq	t0, 312(a0) */
0xa4430008, /* <foo+cc> 	ldq	t1, 8(t2) */
0x40220401, /* <foo+d0> 	addq	t0, t1, t0 */
0xb4300138, /* <foo+d4> 	stq	t0, 312(a0) */
0xb7e30000, /* <foo+d8> 	stq	zero, 0(t2) */
0xb7e30008, /* <foo+dc> 	stq	zero, 8(t2) */
0x40a03405, /* <foo+e0> 	addq	t4, 0x1, t4 */
0x40a25da1, /* <foo+e4> 	cmple	t4, 0x12, t0 */
0xf43ffff5, /* <foo+e8> 	bne	t0, 00000000000000c0 <foo+c0> */
0x42011530, /* <foo+ec> 	subq	a0, 0x8, a0 */
0xa4300058, /* <foo+f0> 	ldq	t0, 88(a0) */
0xb4300000, /* <foo+f4> 	stq	t0, 0(a0) */
0x42011410, /* <foo+f8> 	addq	a0, 0x8, a0 */
0x47ff0405, /* <foo+fc> 	bis	zero, zero, t4 */
0x47e03403, /* <foo+100>	bis	zero, 0x1, t2 */
0x2ffe0000, /* <foo+104>	ldq_u	zero, 0(sp) */
0x47ff041f, /* <foo+108>	bis	zero, zero, zero */
0x2ffe0000, /* <foo+10c>	ldq_u	zero, 0(sp) */
0x47ff041f, /* <foo+110>	bis	zero, zero, zero */
0x2ffe0000, /* <foo+114>	ldq_u	zero, 0(sp) */
0x47ff041f, /* <foo+118>	bis	zero, zero, zero */
0x2ffe0000, /* <foo+11c>	ldq_u	zero, 0(sp) */
0x40a27521, /* <foo+120>	subq	t4, 0x13, t0 */
0xf4200006, /* <foo+124>	bne	t0, 0000000000000140 <foo+140> */
0xa4300138, /* <foo+128>	ldq	t0, 312(a0) */
0x40203401, /* <foo+12c>	addq	t0, 0x1, t0 */
0xb4300138, /* <foo+130>	stq	t0, 312(a0) */
0x6bfa8001, /* <foo+134>	ret	zero, (ra), 1 */
0x47ff041f, /* <foo+138>	bis	zero, zero, zero */
0x2ffe0000, /* <foo+13c>	ldq_u	zero, 0(sp) */
0x48a09721, /* <foo+140>	sll	t4, 0x4, t0 */
0x40300402, /* <foo+144>	addq	t0, a0, t1 */
0xa4220008, /* <foo+148>	ldq	t0, 8(t1) */
0xf4200004, /* <foo+14c>	bne	t0, 0000000000000160 <foo+160> */
0xb6220000, /* <foo+150>	stq	a1, 0(t1) */
0xb4620008, /* <foo+154>	stq	t2, 8(t1) */
0x6bfa8001, /* <foo+158>	ret	zero, (ra), 1 */
0x47ff041f, /* <foo+15c>	bis	zero, zero, zero */
0x48a09721, /* <foo+160>	sll	t4, 0x4, t0 */
0x40300402, /* <foo+164>	addq	t0, a0, t1 */
0xa4220000, /* <foo+168>	ldq	t0, 0(t1) */
0x40310521, /* <foo+16c>	subq	t0, a1, t0 */
0xf4200007, /* <foo+170>	bne	t0, 0000000000000190 <foo+190> */
0xa4220008, /* <foo+174>	ldq	t0, 8(t1) */
0x40203401, /* <foo+178>	addq	t0, 0x1, t0 */
0xb4220008, /* <foo+17c>	stq	t0, 8(t1) */
0x6bfa8001, /* <foo+180>	ret	zero, (ra), 1 */
0x47ff041f, /* <foo+184>	bis	zero, zero, zero */
0x2ffe0000, /* <foo+188>	ldq_u	zero, 0(sp) */
0x47ff041f, /* <foo+18c>	bis	zero, zero, zero */
0x40a03405, /* <foo+190>	addq	t4, 0x1, t4 */
0x40a27da1, /* <foo+194>	cmple	t4, 0x13, t0 */
0xf43fffe1, /* <foo+198>	bne	t0, 0000000000000120 <foo+120> */
0x6bfa8001 /* <foo+19c>	ret	zero, (ra), 1 */
};

/* the produced function takes as an argument the
 * address of the value profiling table (in t6), and
 * the value to be profiled (in t7).
 */ 

extern INDEX ComInsertValueProfiling(FILE *fp) 
{
    INDEX ifun;
    INDEX ibbl;
    INDEX iins;
    int i;
    INDEX firstBbl;
    INDEX secondBbl;
    INDEX thirdBbl;
    INDEX fourthBbl;
    INDEX fifthBbl;
    INDEX sixthBbl;
    INDEX seventhBbl;
    INDEX eighthBbl;
    INDEX ninthBbl;
    INDEX tenthBbl;
    INDEX eleventhBbl;
    INDEX twelvethBbl;
    INDEX thirteenthBbl;
    INDEX fourteenthBbl;
    INDEX fifteenthBbl;
    INDEX sixteenthBbl;
    INDEX seventeenthBbl;
    INDEX eighteenthBbl;
    INDEX ninteenthBbl;
    INDEX twentiethBbl;
    INDEX twenty1stBbl;

    BOOL   verbose = HasOption(PRINT_OPT_VERBOSE,"InsertVP");

    ifun = AfunNewFancy();
    
    AFUN_GP(ifun) = SysGetGlobalPointer();   /* NEEDS WORK */
    AFUN_NAME(ifun) = "sortvalueprofilingtable";


    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    firstBbl = ibbl;


    /* first dump all the registers to the stack */
    iins = AinsNew();
    AinsMakeLda(iins, REG_SP, REG_SP, -64);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);


    /* stq $t0, 0(sp)  */
    iins = AinsNew();
    AinsMakeStq(iins, REG_T0, REG_SP, 0);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);

    
    /* stq $t1, 8(sp)  */
    iins = AinsNew();
    AinsMakeStq(iins, REG_T1, REG_SP, 8);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);

    
    /* stq $t2, 0(sp)  */
    iins = AinsNew();
    AinsMakeStq(iins, REG_T2, REG_SP, 16);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);

    
    /* stq $t3, 0(sp)  */
    iins = AinsNew();
    AinsMakeStq(iins, REG_T3, REG_SP, 24);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);

    
    /* stq $t4, 0(sp)  */
    iins = AinsNew();
    AinsMakeStq(iins, REG_T4, REG_SP, 32);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    
    /* stq $t5, 0(sp)  */
    iins = AinsNew();
    AinsMakeStq(iins, REG_T5, REG_SP, 40);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);


    /* first 8 instructions are for the first bbl */
    for (i = 0; i < 5; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    secondBbl = ibbl;

    for (i = 5; i < 8; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    thirdBbl = ibbl;

    for (i = 8; i < 12; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }


    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    fourthBbl = ibbl;

    for (i = 12; i < 16; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    fifthBbl = ibbl;

    for (i = 16; i < 25; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    sixthBbl = ibbl;

    for (i = 25; i < 27; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    seventhBbl = ibbl;

    for (i = 27; i < 37; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    eighthBbl = ibbl;

    for (i = 37; i < 40; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    ninthBbl = ibbl;

    for (i = 40; i < 48; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    tenthBbl = ibbl;

    for (i = 48; i < 59; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    eleventhBbl = ibbl;

    for (i = 59; i < 62; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }


    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    twelvethBbl = ibbl;

    for (i = 62; i < 72; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }


    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    thirteenthBbl = ibbl;

    for (i = 72; i < 74; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    fourteenthBbl = ibbl;

    for (i = 74; i < 77; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    /* skip return instruction */
    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    fifteenthBbl = ibbl;

    for (i = 78; i < 80; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    sixteenthBbl = ibbl;

    for (i = 80; i < 84; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    seventeenthBbl = ibbl;

    for (i = 84; i < 86; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    eighteenthBbl = ibbl;

    for (i = 88; i < 93; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    ninteenthBbl = ibbl;

    for (i = 93; i < 96; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    twentiethBbl = ibbl;

    for (i = 100; i < 103; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    twenty1stBbl = ibbl;

    iins = AinsNew();
    AinsMakeLdq(iins, REG_SP, REG_T0, 0);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);

    iins = AinsNew();
    AinsMakeLdq(iins, REG_SP, REG_T1, 8);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);

    iins = AinsNew();
    AinsMakeLdq(iins, REG_SP, REG_T2, 16);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);

    iins = AinsNew();
    AinsMakeLdq(iins, REG_SP, REG_T3, 24);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);

    iins = AinsNew();
    AinsMakeLdq(iins, REG_SP, REG_T4, 32);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);

    iins = AinsNew();
    AinsMakeLdq(iins, REG_SP, REG_T5, 40);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);

    iins = AinsNew();
    AinsMakeLda(iins, REG_SP, REG_SP, 64);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);

    



    for (i = 103; i < 104; i++) {
	iins = AinsNew();
	Disassemble(foobar[i], &AINS(iins));
	AINS_BBL(iins) = ibbl;
	AinsAppend(iins);
    }

    /* now we just need to make the links */
    ABBL_TYPE(firstBbl) = BT_BRANCH;
    AedgLinkFancy(AedgNewFancy(firstBbl, secondBbl, ET_FALSE));
    AedgLinkFancy(AedgNewFancy(firstBbl, twelvethBbl, ET_TRUE));

    ABBL_TYPE(secondBbl) = BT_NORM;
    AedgLinkFancy(AedgNewFancy(secondBbl, thirdBbl, ET_NORM));

    ABBL_TYPE(thirdBbl) = BT_BRANCH;
    AedgLinkFancy(AedgNewFancy(thirdBbl, fourthBbl, ET_FALSE));
    AedgLinkFancy(AedgNewFancy(thirdBbl, sixthBbl, ET_TRUE));

    ABBL_TYPE(fourthBbl) = BT_NORM;
    AedgLinkFancy(AedgNewFancy(fourthBbl, fifthBbl, ET_NORM));

    ABBL_TYPE(fifthBbl) = BT_BRANCH;
    AedgLinkFancy(AedgNewFancy(fifthBbl, sixthBbl, ET_FALSE));
    AedgLinkFancy(AedgNewFancy(fifthBbl, fifthBbl, ET_TRUE));

    ABBL_TYPE(sixthBbl) = BT_BRANCH;
    AedgLinkFancy(AedgNewFancy(sixthBbl, eighthBbl, ET_TRUE));
    AedgLinkFancy(AedgNewFancy(sixthBbl, seventhBbl, ET_FALSE));

    ABBL_TYPE(seventhBbl) = BT_NORM;
    AedgLinkFancy(AedgNewFancy(seventhBbl, eighthBbl, ET_NORM));

    ABBL_TYPE(eighthBbl) = BT_BRANCH;
    AedgLinkFancy(AedgNewFancy(eighthBbl, thirdBbl, ET_TRUE));
    AedgLinkFancy(AedgNewFancy(eighthBbl, ninthBbl, ET_FALSE));

    ABBL_TYPE(ninthBbl) = BT_NORM;
    AedgLinkFancy(AedgNewFancy(ninthBbl, tenthBbl, ET_NORM));

    ABBL_TYPE(tenthBbl) = BT_BRANCH;
    AedgLinkFancy(AedgNewFancy(tenthBbl, tenthBbl, ET_TRUE));
    AedgLinkFancy(AedgNewFancy(tenthBbl, eleventhBbl, ET_FALSE));

    ABBL_TYPE(eleventhBbl) = BT_NORM;
    AedgLinkFancy(AedgNewFancy(eleventhBbl, twelvethBbl, ET_NORM));

    ABBL_TYPE(twelvethBbl) = BT_NORM;
    AedgLinkFancy(AedgNewFancy(twelvethBbl, thirteenthBbl, ET_NORM));

    ABBL_TYPE(thirteenthBbl) = BT_BRANCH;
    AedgLinkFancy(AedgNewFancy(thirteenthBbl, sixteenthBbl, ET_TRUE));
    AedgLinkFancy(AedgNewFancy(thirteenthBbl, fourteenthBbl, ET_FALSE));
    
    /* return after fourteenth */
    ABBL_TYPE(fourteenthBbl) = BT_NORM;
    AedgLinkFancy(AedgNewFancy(fourteenthBbl, twenty1stBbl, ET_NORM));

    ABBL_TYPE(fifteenthBbl) = BT_NORM;
    AedgLinkFancy(AedgNewFancy(fifteenthBbl, sixteenthBbl, ET_NORM));

    ABBL_TYPE(sixteenthBbl) = BT_BRANCH;
    AedgLinkFancy(AedgNewFancy(sixteenthBbl, eighteenthBbl, ET_TRUE));
    AedgLinkFancy(AedgNewFancy(sixteenthBbl, seventeenthBbl, ET_FALSE));
    
    ABBL_TYPE(seventeenthBbl) = BT_NORM;
    AedgLinkFancy(AedgNewFancy(seventeenthBbl, twenty1stBbl, ET_NORM));
    
    ABBL_TYPE(eighteenthBbl) = BT_BRANCH;
    AedgLinkFancy(AedgNewFancy(eighteenthBbl, twentiethBbl, ET_TRUE));
    AedgLinkFancy(AedgNewFancy(eighteenthBbl, ninteenthBbl, ET_FALSE));

    ABBL_TYPE(ninteenthBbl) = BT_NORM;
    AedgLinkFancy(AedgNewFancy(ninteenthBbl, twenty1stBbl, ET_NORM));

    ABBL_TYPE(twentiethBbl) = BT_BRANCH;
    AedgLinkFancy(AedgNewFancy(twentiethBbl, thirteenthBbl, ET_TRUE));
    AedgLinkFancy(AedgNewFancy(twentiethBbl, twenty1stBbl, ET_FALSE));

    ABBL_TYPE(twenty1stBbl) = BT_RET;
    AedgLinkFancy(AedgNewFancy(twenty1stBbl, twenty1stBbl, ET_EXIT_LINK));


    if (verbose) {
	PrintFunSuper(fp, ifun);
    }

    return AFUN_BBL_FIRST(ifun);

}




extern int CountVPCode(FILE *fp) 
{
    REG reg;
    INDEX ifun;
    INDEX ibbl;
    INDEX iins;
    NUMBER count = 0;

    if (!HasOption(CONFIG_PROFILE_WHAT, "Value")) {
	return 0;
    }

    ComUseDef(stdout, 1);
    ComInsDefPotential(stdout, 1);

    printf("XXXXXXXXXXXXX\n");

    FOREACH_LIVE_FUN(ifun) {
	for( reg=0; reg <64; reg++ )	{
	    if (AFUN_ARG_FLAGS(ifun,reg) & F_MARKED) {
		printf("\t[*]fun: %d [%s] reg %d  pot: %ld\n",
		       ifun,AFUN_NAME(ifun),reg,AFUN_USE_DEF_ARG_POTENTIAL(ifun,reg));
		count++;
	    }
	}
	FOREACH_FUN_BBL(ifun,ibbl) {
	    if( !ABBL_IS_HOT(ibbl) ) continue;
	    
	    FOREACH_BBL_INS(ibbl,iins) {
		if (AINS_FLAGS(iins) & F_MARKED) {
		    printf("\t[*]fun: %d [%s] ins %d    bbl: %d   pot:  %ld\n",
			   ifun,AFUN_NAME(ifun),iins,ibbl,AINS_USE_DEF_POTENTIAL(iins));
		    PrintIns(stdout,iins);
		    count++;
		}
	    }
	}
    }

    return count;
}



/* break bbl just after instruction iins, put the top half 
 * in the new bbl  */
extern INDEX AbblSplit(INDEX ibbl, INDEX iins) 
{
    INDEX newbbl;
    INDEX kins, jins;

    newbbl = AbblNew();
    ABBL_FUN(newbbl) = ABBL_FUN(ibbl);
    AbblAppendFancy(newbbl);

    /* now move the instructions into the new bbl */
    
    jins = AINS_NEXT(iins);

    /* should make prev be invalid when we've moved
     * the iins up to the top half */
    while (jins != INVALID) {
	kins = jins;
	jins = AINS_NEXT(jins);

	AinsUnlink(kins);
	AINS_NEXT(kins) = AINS_PREV(kins) = INVALID;

	AINS_BBL(kins) = newbbl;
	AinsAppend(kins);
    }


    return newbbl;
}


#undef __PROC__
#define __PROC__ "ComInsertVPIins"
extern int ComInsertVPIins(ADDRESS counterstart, INDEX jins, REG reg, INDEX sweepFunBbl, FILE *fp) 
{
    INDEX ifun;
    INDEX ibbl;
    INDEX iins;
    REG prof1, prof2, prof3;
    REG target;
    INDEX newBbl, startBbl, resetBbl;
    INDEX iedg;
    INDEX jbbl;
    NUMBER count = 0;
    NUMBER high, low;
    ADDRESS Y;
    BOOL verbose = HasOption(PRINT_OPT_VERBOSE, "ValueProf");
    verbose = 1;

    jbbl = AINS_BBL(jins);

    PrintIns(stdout,jins);
    
    ifun = ABBL_FUN(jbbl);
    
    CERROR((jins == ABBL_INS_LAST(jbbl)), ("Attempt to split last instruction %d of bbl %d\n", jins, jbbl));
    
    /* these are needed for the function call, do not use free
       registers.  We can store them in a free register instead
       of the stack if we need to, but that my be overkill.
       */
    
    /* at some point we may set these to be free registers */
    prof1 = REG_A0;
    prof2 = REG_A1;
    prof3 = REG_RA;
    target = reg;
    
    PrintBblSuper(stdout, jbbl);
    
    
    /* need to split bbl */
    newBbl = AbblSplit(jbbl, jins);
    ABBL_TYPE(newBbl) = ABBL_TYPE(jbbl);
    
    /* newbbl needs to get edges from ibbl */
    FOREACH_BBL_SUCC(jbbl,iedg) {
	INDEX jedg = AedgNewFancy(newBbl,AEDG_TAIL(iedg),AEDG_TYPE(iedg));
	AedgLinkFancy(jedg);
	AedgKillFancy(iedg);
    }
    printf("XZZZ\n");
    PrintBblSuper(stdout, newBbl);
    printf("XZZZ\n");
    ABBL_TYPE(jbbl) = BT_NORM;
    PrintBblSuper(stdout, jbbl);
    
    /* ok, now add a some bbls to handle table lookups */
    startBbl = jbbl;
    ibbl = jbbl;
    
    /* dec sp by 24 (enough to store 3 registers) */
    iins = AinsNew();
    AinsMakeLda(iins, REG_SP, REG_SP, -24);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    /* stq $a0, 8(sp)  */
    iins = AinsNew();
    AinsMakeStq(iins, prof1, REG_SP, 0);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    /* stq $a1, 0(sp)  */
    iins = AinsNew();
    AinsMakeStq(iins, prof2, REG_SP, 8);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    /* stq $a1, 0(sp)  */
    iins = AinsNew();
    AinsMakeStq(iins, prof3, REG_SP, 16);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    /* do the actual counter manipulations here */
    Y = counterstart;
    
    if (verbose) {
	fprintf(fp, "starting counter at %lx, count is %d\n", Y, count);
	fprintf(fp, "address profiled is %lx\n", Ins2Addr(jins));
	fprintf(fp, "register profiled is %d\n", reg);
    }
    /* store the instruction profiled */
    WriteData64(Y, ((long)reg << 32) | (long)jins);
    
    /* store the counter for value profiling */
    WriteData64(Y+8, START_PROF);
    
    /* store the -1 target value as a catchall */
/*     WriteData64(Y + (CALL_PROF_SIZE - 16), -1); */
    
    Y += 8;  /* move past the address and counter */
    Y -= SysGetGlobalPointer();
    
    
    high = Y >> 16;
    low = Y & 0xffff;
    if( low & 0x8000 )
    {
	low |= 0xffff0000;
	high += 1;
    }
#if 0
    WARNING(("Y %16lx  high %8lx  low %8x\n",Y,high,low));
#endif
    CASSERT( ((long)high << 16) + (long) low == Y,("bad table address computation\n"));
    
    /* set the register to be profiled to be a1 */
    iins = AinsNew();
    AinsMakeLda(iins, target, prof2, 0);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    
    /* set the t1 to counter address */
    iins = AinsNew();
    AinsMakeLdah(iins,REG_GP, prof1 ,high);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    iins = AinsNew();
    AinsMakeLda(iins,prof1, prof1 ,low);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    
    /* call the function */
    iins = AinsNew();
    AinsMakeBsr(iins, prof3);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    /* ok, call bbl is in place */
    
    /* restore when we return */
    
    ibbl = AbblNew();
    ABBL_FUN(ibbl) = ifun;
    AbblAppendFancy(ibbl);
    resetBbl = ibbl;
    
    /* ldq $ra, 8(sp)  */
    iins = AinsNew();
    AinsMakeLdq(iins, REG_SP, prof3, 16);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    /* ldq $a0, 0(sp)  */
    iins = AinsNew();
    AinsMakeLdq(iins, REG_SP, prof2, 8);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
		    
    /* ldq $a0, 0(sp)  */
    iins = AinsNew();
    AinsMakeLdq(iins, REG_SP, prof1, 0);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    /* reset stack */
    iins = AinsNew();
    AinsMakeLda(iins, REG_SP, REG_SP , 24);
    AINS_BBL(iins) = ibbl;
    AinsAppend(iins);
    
    /* now set up links to new blocks */
    ABBL_TYPE(startBbl) = BT_CALL;
    AedgLinkFancy(AedgNewFancy(startBbl, resetBbl, ET_FUN_LINK));
    AedgLinkFancy(AedgNewFancy(startBbl, sweepFunBbl, ET_FUN_CALL));
		    
		    
    ABBL_TYPE(resetBbl) = BT_NORM;
    AedgLinkFancy(AedgNewFancy(resetBbl, newBbl, ET_NORM));
    
    
    if (verbose) {
	printf("FFFFFFFFFOOOOOOO\n");
	PrintBblSuper(fp, AINS_BBL(jins));
	PrintBblSuper(fp, startBbl);
	PrintBblSuper(fp, resetBbl);
	PrintBblSuper(fp, newBbl);
    }
    return 1;
    
}



#undef __PROC__
#define __PROC__ "ComInsertValueProfilingInformation"

extern int ComInsertValueProfilingInformation(ADDRESS counterstart, INDEX sweepFunBbl, FILE *fp) 
{
    REG reg;
    INDEX ifun;
    INDEX jins;
    INDEX jbbl;
    NUMBER count = 0;
    ADDRESS Y;
    BOOL verbose = HasOption(PRINT_OPT_VERBOSE, "ValueProf");
    verbose = 1;

    count = 0;
    printf("XXXXXXXXXXXXX\n");

    FOREACH_LIVE_FUN(ifun) {
	for( reg=0; reg <64; reg++ )	{
	    if (AFUN_ARG_FLAGS(ifun,reg) & F_MARKED) {
		printf("\t[*]fun: %d [%s] reg %d  pot: %ld\n",
		       ifun,AFUN_NAME(ifun),reg,AFUN_USE_DEF_ARG_POTENTIAL(ifun,reg));
		jbbl = AFUN_BBL_FIRST(ifun);
		jins = ABBL_INS_FIRST(jbbl);
		Y = counterstart + (count)*(CALL_PROF_SIZE);
		ComInsertVPIins(Y, jins, reg, sweepFunBbl, fp);
		count++;
		
	    }
	}
	FOREACH_FUN_BBL(ifun,jbbl) {
	    if( !ABBL_IS_HOT(jbbl) ) continue;
	    
	    FOREACH_BBL_INS(jbbl,jins) {
		if (AINS_FLAGS(jins) & F_MARKED) {
		    printf("\t[*]fun: %d [%s] ins %d    bbl: %d   pot:  %ld\n",
			   ifun,AFUN_NAME(ifun),jins,jbbl,AINS_USE_DEF_POTENTIAL(jins));
		    Y = counterstart + (count)*(CALL_PROF_SIZE);
		    ComInsertVPIins(Y, jins, AINS_REG_C(jins), sweepFunBbl, fp);
		    count++;
		}
	    }
	}
    }

    fprintf(fp,"\t[InsertValueProfiling] total: %d\n", count);
    return count;
}
